<center><a href="ex5.c">Actual source code: ex5.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:31:06+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Bratu nonlinear PDE in 2d.\n\</font>
<a name="line3">  3: </a><font color="#666666">We solve the  Bratu (SFI - solid fuel ignition) problem in a 2D rectangular\n\</font>
<a name="line4">  4: </a><font color="#666666">domain, using distributed arrays (DAs) to partition the parallel grid.\n\</font>
<a name="line5">  5: </a><font color="#666666">The command line options include:\n\</font>
<a name="line6">  6: </a><font color="#666666">  -par &lt;parameter&gt;, where &lt;parameter&gt; indicates the problem's nonlinearity\n\</font>
<a name="line7">  7: </a><font color="#666666">     problem SFI:  &lt;parameter&gt; = Bratu parameter (0 &lt;= par &lt;= 6.81)\n\n"</font>;

<a name="line9">  9: </a><font color="#B22222">/*T</font>
<a name="line10"> 10: </a><font color="#B22222">   Concepts: <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A>^parallel Bratu example</font>
<a name="line11"> 11: </a><font color="#B22222">   Concepts: <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>^using distributed arrays;</font>
<a name="line12"> 12: </a><font color="#B22222">   Concepts: <A href="../../../../docs/manualpages/IS/IS.html#IS">IS</A> coloirng types;</font>
<a name="line13"> 13: </a><font color="#B22222">   Processors: n</font>
<a name="line14"> 14: </a><font color="#B22222">T*/</font>

<a name="line16"> 16: </a><font color="#B22222">/* ------------------------------------------------------------------------</font>

<a name="line18"> 18: </a><font color="#B22222">    Solid Fuel Ignition (SFI) problem.  This problem is modeled by</font>
<a name="line19"> 19: </a><font color="#B22222">    the partial differential equation</font>
<a name="line20"> 20: </a><font color="#B22222">  </font>
<a name="line21"> 21: </a><font color="#B22222">            -Laplacian u - lambda*exp(u) = 0,  0 &lt; x,y &lt; 1,</font>
<a name="line22"> 22: </a><font color="#B22222">  </font>
<a name="line23"> 23: </a><font color="#B22222">    with boundary conditions</font>
<a name="line24"> 24: </a><font color="#B22222">   </font>
<a name="line25"> 25: </a><font color="#B22222">             u = 0  for  x = 0, x = 1, y = 0, y = 1.</font>
<a name="line26"> 26: </a><font color="#B22222">  </font>
<a name="line27"> 27: </a><font color="#B22222">    A finite difference approximation with the usual 5-point stencil</font>
<a name="line28"> 28: </a><font color="#B22222">    is used to discretize the boundary value problem to obtain a nonlinear </font>
<a name="line29"> 29: </a><font color="#B22222">    system of equations.</font>

<a name="line31"> 31: </a><font color="#B22222">    Program usage:  <A href="http://www.mcs.anl.gov/mpi/www/www1/mpirun.html#mpirun">mpirun</A> -np &lt;procs&gt; ex5 [-help] [all PETSc options] </font>
<a name="line32"> 32: </a><font color="#B22222">     e.g.,</font>
<a name="line33"> 33: </a><font color="#B22222">      ./ex5 -fd_jacobian -mat_fd_coloring_view_draw -draw_pause -1</font>
<a name="line34"> 34: </a><font color="#B22222">      <A href="http://www.mcs.anl.gov/mpi/www/www1/mpirun.html#mpirun">mpirun</A> -np 2 ./ex5 -fd_jacobian_ghosted -log_summary</font>

<a name="line36"> 36: </a><font color="#B22222">  ------------------------------------------------------------------------- */</font>

<a name="line38"> 38: </a><font color="#B22222">/* </font>
<a name="line39"> 39: </a><font color="#B22222">   Include "petscda.h" so that we can use distributed arrays (DAs).</font>
<a name="line40"> 40: </a><font color="#B22222">   Include "petscsnes.h" so that we can use <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> solvers.  Note that this</font>
<a name="line41"> 41: </a><font color="#B22222">   file automatically includes:</font>
<a name="line42"> 42: </a><font color="#B22222">     petsc.h       - base PETSc routines   petscvec.h - vectors</font>
<a name="line43"> 43: </a><font color="#B22222">     petscsys.h    - system routines       petscmat.h - matrices</font>
<a name="line44"> 44: </a><font color="#B22222">     petscis.h     - index sets            petscksp.h - Krylov subspace methods</font>
<a name="line45"> 45: </a><font color="#B22222">     petscviewer.h - viewers               petscpc.h  - preconditioners</font>
<a name="line46"> 46: </a><font color="#B22222">     petscksp.h   - linear solvers</font>
<a name="line47"> 47: </a><font color="#B22222">*/</font>
<a name="line48"> 48: </a> #include <A href="../../../../include/petscda.h.html">petscda.h</A>
<a name="line49"> 49: </a> #include <A href="../../../../include/petscsnes.h.html">petscsnes.h</A>

<a name="line51"> 51: </a><font color="#B22222">/* </font>
<a name="line52"> 52: </a><font color="#B22222">   User-defined application context - contains data needed by the </font>
<a name="line53"> 53: </a><font color="#B22222">   application-provided call-back routines, FormJacobianLocal() and</font>
<a name="line54"> 54: </a><font color="#B22222">   FormFunctionLocal().</font>
<a name="line55"> 55: </a><font color="#B22222">*/</font>
<a name="line56"> 56: </a><font color="#4169E1">typedef</font> <font color="#4169E1">struct</font> {
<a name="line57"> 57: </a>   <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>          da;             <font color="#B22222">/* distributed array data structure */</font>
<a name="line58"> 58: </a>   <A href="../../../../docs/manualpages/Sys/PassiveReal.html#PassiveReal">PassiveReal</A> param;          <font color="#B22222">/* test problem parameter */</font>
<a name="line59"> 59: </a>} AppCtx;

<a name="line61"> 61: </a><font color="#B22222">/* </font>
<a name="line62"> 62: </a><font color="#B22222">   User-defined routines</font>
<a name="line63"> 63: </a><font color="#B22222">*/</font>

<a name="line71"> 71: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **argv)</font></strong>
<a name="line72"> 72: </a>{
<a name="line73"> 73: </a>  <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A>                   snes;                 <font color="#B22222">/* nonlinear solver */</font>
<a name="line74"> 74: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>                    x,r;                  <font color="#B22222">/* solution, residual vectors */</font>
<a name="line75"> 75: </a>  <A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>                    A,J;                    <font color="#B22222">/* Jacobian matrix */</font>
<a name="line76"> 76: </a>  AppCtx                 user;                 <font color="#B22222">/* user-defined work context */</font>
<a name="line77"> 77: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>               its;                  <font color="#B22222">/* iterations for convergence */</font>
<a name="line78"> 78: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>             matlab_function = <A href="../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line79"> 79: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>             fd_jacobian = <A href="../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>,adic_jacobian=<A href="../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>,fd_jacobian_ghosted=<A href="../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line80"> 80: </a>  <A href="../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>             adicmf_jacobian = <A href="../../../../docs/manualpages/Sys/PETSC_FALSE.html#PETSC_FALSE">PETSC_FALSE</A>;
<a name="line81"> 81: </a>  <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>         ierr;
<a name="line82"> 82: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>              bratu_lambda_max = 6.81,bratu_lambda_min = 0.;
<a name="line83"> 83: </a>  <A href="../../../../docs/manualpages/Mat/MatFDColoring.html#MatFDColoring">MatFDColoring</A>          matfdcoloring = 0;
<a name="line84"> 84: </a>  <A href="../../../../docs/manualpages/IS/ISColoring.html#ISColoring">ISColoring</A>             iscoloring;

<a name="line86"> 86: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line87"> 87: </a><font color="#B22222">     Initialize program</font>
<a name="line88"> 88: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line90"> 90: </a>  <A href="../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;argv,(char *)0,help);

<a name="line92"> 92: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line93"> 93: </a><font color="#B22222">     Initialize problem parameters</font>
<a name="line94"> 94: </a><font color="#B22222">  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line95"> 95: </a>  user.param = 6.0;
<a name="line96"> 96: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetReal.html#PetscOptionsGetReal">PetscOptionsGetReal</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-par"</font>,&amp;user.param,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line97"> 97: </a>  <font color="#4169E1">if</font> (user.param &gt;= bratu_lambda_max || user.param &lt;= bratu_lambda_min) {
<a name="line98"> 98: </a>    <A href="../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,<font color="#666666">"Lambda is out of range"</font>);
<a name="line99"> 99: </a>  }

<a name="line101">101: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line102">102: </a><font color="#B22222">     Create nonlinear solver context</font>
<a name="line103">103: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line104">104: </a>  <A href="../../../../docs/manualpages/SNES/SNESCreate.html#SNESCreate">SNESCreate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,&amp;snes);

<a name="line106">106: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line107">107: </a><font color="#B22222">     Create distributed array (<A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>) to manage parallel grid and vectors</font>
<a name="line108">108: </a><font color="#B22222">  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line109">109: </a>  <A href="../../../../docs/manualpages/DA/DACreate2d.html#DACreate2d">DACreate2d</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,DA_NONPERIODIC,<A href="../../../../docs/manualpages/DA/DA_STENCIL_STAR.html#DA_STENCIL_STAR">DA_STENCIL_STAR</A>,-4,-4,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,
<a name="line110">110: </a>                    1,1,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;user.da);

<a name="line112">112: </a>  <font color="#B22222">/*  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line113">113: </a><font color="#B22222">     Extract global vectors from <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>; then duplicate for remaining</font>
<a name="line114">114: </a><font color="#B22222">     vectors that are the same types</font>
<a name="line115">115: </a><font color="#B22222">   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line116">116: </a>  <A href="../../../../docs/manualpages/DA/DACreateGlobalVector.html#DACreateGlobalVector">DACreateGlobalVector</A>(user.da,&amp;x);
<a name="line117">117: </a>  <A href="../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(x,&amp;r);

<a name="line119">119: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line120">120: </a><font color="#B22222">     Create matrix data structure; set Jacobian evaluation routine</font>

<a name="line122">122: </a><font color="#B22222">     Set Jacobian matrix data structure and default Jacobian evaluation</font>
<a name="line123">123: </a><font color="#B22222">     routine. User can override with:</font>
<a name="line124">124: </a><font color="#B22222">     -snes_mf : matrix-free Newton-Krylov method with no preconditioning</font>
<a name="line125">125: </a><font color="#B22222">                (unless user explicitly sets preconditioner) </font>
<a name="line126">126: </a><font color="#B22222">     -snes_mf_operator : form preconditioning matrix as set by the user,</font>
<a name="line127">127: </a><font color="#B22222">                         but use matrix-free approx for Jacobian-vector</font>
<a name="line128">128: </a><font color="#B22222">                         products within Newton-Krylov method</font>

<a name="line130">130: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line131">131: </a>  <font color="#B22222">/* J can be type of <A href="../../../../docs/manualpages/Mat/MATAIJ.html#MATAIJ">MATAIJ</A>,<A href="../../../../docs/manualpages/Mat/MATBAIJ.html#MATBAIJ">MATBAIJ</A> or <A href="../../../../docs/manualpages/Mat/MATSBAIJ.html#MATSBAIJ">MATSBAIJ</A> */</font>
<a name="line132">132: </a>  <A href="../../../../docs/manualpages/DA/DAGetMatrix.html#DAGetMatrix">DAGetMatrix</A>(user.da,<A href="../../../../docs/manualpages/Mat/MATAIJ.html#MATAIJ">MATAIJ</A>,&amp;J);
<a name="line133">133: </a>
<a name="line134">134: </a>  A    = J;
<a name="line135">135: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetTruth.html#PetscOptionsGetTruth">PetscOptionsGetTruth</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-fd_jacobian"</font>,&amp;fd_jacobian,0);
<a name="line136">136: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetTruth.html#PetscOptionsGetTruth">PetscOptionsGetTruth</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-fd_jacobian_ghosted"</font>,&amp;fd_jacobian_ghosted,0);
<a name="line137">137: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetTruth.html#PetscOptionsGetTruth">PetscOptionsGetTruth</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-adic_jacobian"</font>,&amp;adic_jacobian,0);
<a name="line138">138: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetTruth.html#PetscOptionsGetTruth">PetscOptionsGetTruth</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-adicmf_jacobian"</font>,&amp;adicmf_jacobian,0);
<a name="line139">139: </a><font color="#A020F0">#if defined(PETSC_HAVE_ADIC)</font>
<a name="line140">140: </a>  <font color="#4169E1">if</font> (adicmf_jacobian) {
<a name="line141">141: </a>    <A href="../../../../docs/manualpages/DA/DASetLocalAdicMFFunction.html#DASetLocalAdicMFFunction">DASetLocalAdicMFFunction</A>(user.da,admf_FormFunctionLocal);
<a name="line142">142: </a>    <A href="../../../../docs/manualpages/Mat/MatRegisterDAAD.html#MatRegisterDAAD">MatRegisterDAAD</A>();
<a name="line143">143: </a>    <A href="../../../../docs/manualpages/Mat/MatCreateDAAD.html#MatCreateDAAD">MatCreateDAAD</A>(user.da,&amp;A);
<a name="line144">144: </a>    <A href="../../../../docs/manualpages/Mat/MatDAADSetSNES.html#MatDAADSetSNES">MatDAADSetSNES</A>(A,snes);
<a name="line145">145: </a>    <A href="../../../../docs/manualpages/Mat/MatDAADSetCtx.html#MatDAADSetCtx">MatDAADSetCtx</A>(A,&amp;user);
<a name="line146">146: </a>  }
<a name="line147">147: </a><font color="#A020F0">#endif</font>

<a name="line149">149: </a>  <font color="#4169E1">if</font> (fd_jacobian) {
<a name="line150">150: </a>    <A href="../../../../docs/manualpages/DA/DAGetColoring.html#DAGetColoring">DAGetColoring</A>(user.da,IS_COLORING_LOCAL,&amp;iscoloring);
<a name="line151">151: </a>    <A href="../../../../docs/manualpages/MatFD/MatFDColoringCreate.html#MatFDColoringCreate">MatFDColoringCreate</A>(J,iscoloring,&amp;matfdcoloring);
<a name="line152">152: </a>    <A href="../../../../docs/manualpages/IS/ISColoringDestroy.html#ISColoringDestroy">ISColoringDestroy</A>(iscoloring);
<a name="line153">153: </a>    <A href="../../../../docs/manualpages/MatFD/MatFDColoringSetFunction.html#MatFDColoringSetFunction">MatFDColoringSetFunction</A>(matfdcoloring,(<A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*)(void))<A href="../../../../docs/manualpages/DA/SNESDAFormFunction.html#SNESDAFormFunction">SNESDAFormFunction</A>,&amp;user);
<a name="line154">154: </a>    <A href="../../../../docs/manualpages/MatFD/MatFDColoringSetFromOptions.html#MatFDColoringSetFromOptions">MatFDColoringSetFromOptions</A>(matfdcoloring);
<a name="line155">155: </a>    <A href="../../../../docs/manualpages/SNES/SNESSetJacobian.html#SNESSetJacobian">SNESSetJacobian</A>(snes,A,J,<A href="../../../../docs/manualpages/SNES/SNESDefaultComputeJacobianColor.html#SNESDefaultComputeJacobianColor">SNESDefaultComputeJacobianColor</A>,matfdcoloring);
<a name="line156">156: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (fd_jacobian_ghosted) {
<a name="line157">157: </a>    <A href="../../../../docs/manualpages/DA/DAGetColoring.html#DAGetColoring">DAGetColoring</A>(user.da,IS_COLORING_GHOSTED,&amp;iscoloring);
<a name="line158">158: </a>    <A href="../../../../docs/manualpages/MatFD/MatFDColoringCreate.html#MatFDColoringCreate">MatFDColoringCreate</A>(J,iscoloring,&amp;matfdcoloring);
<a name="line159">159: </a>    <A href="../../../../docs/manualpages/IS/ISColoringDestroy.html#ISColoringDestroy">ISColoringDestroy</A>(iscoloring);
<a name="line160">160: </a>    <A href="../../../../docs/manualpages/MatFD/MatFDColoringSetFunction.html#MatFDColoringSetFunction">MatFDColoringSetFunction</A>(matfdcoloring,(<A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*)(void))<A href="../../../../docs/manualpages/DA/SNESDAFormFunction.html#SNESDAFormFunction">SNESDAFormFunction</A>,&amp;user);
<a name="line161">161: </a>    <A href="../../../../docs/manualpages/MatFD/MatFDColoringSetFromOptions.html#MatFDColoringSetFromOptions">MatFDColoringSetFromOptions</A>(matfdcoloring);
<a name="line162">162: </a>    <font color="#B22222">/* now, call a customized <A href="../../../../docs/manualpages/SNES/SNESDefaultComputeJacobianColor.html#SNESDefaultComputeJacobianColor">SNESDefaultComputeJacobianColor</A>() */</font>
<a name="line163">163: </a>    <A href="../../../../docs/manualpages/SNES/SNESSetJacobian.html#SNESSetJacobian">SNESSetJacobian</A>(snes,A,J,MySNESDefaultComputeJacobianColor,matfdcoloring);
<a name="line164">164: </a><font color="#A020F0">#if defined(PETSC_HAVE_ADIC)</font>
<a name="line165">165: </a>  } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (adic_jacobian) {
<a name="line166">166: </a>    <A href="../../../../docs/manualpages/DA/DAGetColoring.html#DAGetColoring">DAGetColoring</A>(user.da,IS_COLORING_GHOSTED,&amp;iscoloring);
<a name="line167">167: </a>    <A href="../../../../docs/manualpages/Mat/MatSetColoring.html#MatSetColoring">MatSetColoring</A>(J,iscoloring);
<a name="line168">168: </a>    <A href="../../../../docs/manualpages/IS/ISColoringDestroy.html#ISColoringDestroy">ISColoringDestroy</A>(iscoloring);
<a name="line169">169: </a>    <A href="../../../../docs/manualpages/SNES/SNESSetJacobian.html#SNESSetJacobian">SNESSetJacobian</A>(snes,A,J,<A href="../../../../docs/manualpages/DA/SNESDAComputeJacobianWithAdic.html#SNESDAComputeJacobianWithAdic">SNESDAComputeJacobianWithAdic</A>,&amp;user);
<a name="line170">170: </a><font color="#A020F0">#endif</font>
<a name="line171">171: </a>  } <font color="#4169E1">else</font> {
<a name="line172">172: </a>    <A href="../../../../docs/manualpages/SNES/SNESSetJacobian.html#SNESSetJacobian">SNESSetJacobian</A>(snes,A,J,SNESDAComputeJacobian,&amp;user);
<a name="line173">173: </a>  }

<a name="line175">175: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line176">176: </a><font color="#B22222">     Set local function evaluation routine</font>
<a name="line177">177: </a><font color="#B22222">  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line178">178: </a>  <A href="../../../../docs/manualpages/DA/DASetLocalFunction.html#DASetLocalFunction">DASetLocalFunction</A>(user.da,(DALocalFunction1)FormFunctionLocal);
<a name="line179">179: </a>  <A href="../../../../docs/manualpages/DA/DASetLocalJacobian.html#DASetLocalJacobian">DASetLocalJacobian</A>(user.da,(DALocalFunction1)FormJacobianLocal);
<a name="line180">180: </a>  <A href="../../../../docs/manualpages/DA/DASetLocalAdicFunction.html#DASetLocalAdicFunction">DASetLocalAdicFunction</A>(user.da,ad_FormFunctionLocal);

<a name="line182">182: </a>  <font color="#B22222">/* Decide which FormFunction to use */</font>
<a name="line183">183: </a>  <A href="../../../../docs/manualpages/Sys/PetscOptionsGetTruth.html#PetscOptionsGetTruth">PetscOptionsGetTruth</A>(<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-matlab_function"</font>,&amp;matlab_function,0);

<a name="line185">185: </a>  <A href="../../../../docs/manualpages/SNES/SNESSetFunction.html#SNESSetFunction">SNESSetFunction</A>(snes,r,<A href="../../../../docs/manualpages/DA/SNESDAFormFunction.html#SNESDAFormFunction">SNESDAFormFunction</A>,&amp;user);
<a name="line186">186: </a><font color="#A020F0">#if defined(PETSC_HAVE_MATLAB)</font>
<a name="line187">187: </a>  <font color="#4169E1">if</font> (matlab_function) {
<a name="line188">188: </a>    <A href="../../../../docs/manualpages/SNES/SNESSetFunction.html#SNESSetFunction">SNESSetFunction</A>(snes,r,FormFunctionMatlab,&amp;user);
<a name="line189">189: </a>  }
<a name="line190">190: </a><font color="#A020F0">#endif</font>

<a name="line192">192: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line193">193: </a><font color="#B22222">     Customize nonlinear solver; set runtime options</font>
<a name="line194">194: </a><font color="#B22222">   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line195">195: </a>  <A href="../../../../docs/manualpages/SNES/SNESSetFromOptions.html#SNESSetFromOptions">SNESSetFromOptions</A>(snes);

<a name="line197">197: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line198">198: </a><font color="#B22222">     Evaluate initial guess</font>
<a name="line199">199: </a><font color="#B22222">     Note: The user should initialize the vector, x, with the initial guess</font>
<a name="line200">200: </a><font color="#B22222">     for the nonlinear solver prior to calling <A href="../../../../docs/manualpages/SNES/SNESSolve.html#SNESSolve">SNESSolve</A>().  In particular,</font>
<a name="line201">201: </a><font color="#B22222">     to employ an initial guess of zero, the user should explicitly set</font>
<a name="line202">202: </a><font color="#B22222">     this vector to zero by calling <A href="../../../../docs/manualpages/Vec/VecSet.html#VecSet">VecSet</A>().</font>
<a name="line203">203: </a><font color="#B22222">  */</font>
<a name="line204">204: </a>  FormInitialGuess(&amp;user,x);

<a name="line206">206: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line207">207: </a><font color="#B22222">     Solve nonlinear system</font>
<a name="line208">208: </a><font color="#B22222">     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line209">209: </a>  <A href="../../../../docs/manualpages/SNES/SNESSolve.html#SNESSolve">SNESSolve</A>(snes,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,x);
<a name="line210">210: </a>  <A href="../../../../docs/manualpages/SNES/SNESGetIterationNumber.html#SNESGetIterationNumber">SNESGetIterationNumber</A>(snes,&amp;its);

<a name="line212">212: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line213">213: </a><font color="#B22222">   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>
<a name="line214">214: </a>  <A href="../../../../docs/manualpages/Sys/PetscPrintf.html#PetscPrintf">PetscPrintf</A>(<A href="../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,<font color="#666666">"Number of Newton iterations = %D\n"</font>,its);

<a name="line216">216: </a>  <font color="#B22222">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -</font>
<a name="line217">217: </a><font color="#B22222">     Free work space.  All PETSc objects should be destroyed when they</font>
<a name="line218">218: </a><font color="#B22222">     are no longer needed.</font>
<a name="line219">219: </a><font color="#B22222">   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</font>

<a name="line221">221: </a>  <font color="#4169E1">if</font> (A != J) {
<a name="line222">222: </a>    <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(A);
<a name="line223">223: </a>  }
<a name="line224">224: </a>  <A href="../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(J);
<a name="line225">225: </a>  <font color="#4169E1">if</font> (matfdcoloring) {
<a name="line226">226: </a>    <A href="../../../../docs/manualpages/MatFD/MatFDColoringDestroy.html#MatFDColoringDestroy">MatFDColoringDestroy</A>(matfdcoloring);
<a name="line227">227: </a>  }
<a name="line228">228: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(x);
<a name="line229">229: </a>  <A href="../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(r);
<a name="line230">230: </a>  <A href="../../../../docs/manualpages/SNES/SNESDestroy.html#SNESDestroy">SNESDestroy</A>(snes);
<a name="line231">231: </a>  <A href="../../../../docs/manualpages/DA/DADestroy.html#DADestroy">DADestroy</A>(user.da);
<a name="line232">232: </a>  <A href="../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();

<a name="line234">234: </a>  <font color="#4169E1">return</font>(0);
<a name="line235">235: </a>}
<a name="line236">236: </a><font color="#B22222">/* ------------------------------------------------------------------- */</font>
<a name="line239">239: </a><font color="#B22222">/* </font>
<a name="line240">240: </a><font color="#B22222">   FormInitialGuess - Forms initial approximation.</font>

<a name="line242">242: </a><font color="#B22222">   Input Parameters:</font>
<a name="line243">243: </a><font color="#B22222">   user - user-defined application context</font>
<a name="line244">244: </a><font color="#B22222">   X - vector</font>

<a name="line246">246: </a><font color="#B22222">   Output Parameter:</font>
<a name="line247">247: </a><font color="#B22222">   X - vector</font>
<a name="line248">248: </a><font color="#B22222"> */</font>
<a name="line249">249: </a><strong><font color="#4169E1"><a name="FormInitialGuess"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> FormInitialGuess(AppCtx *user,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> X)</font></strong>
<a name="line250">250: </a>{
<a name="line251">251: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,j,Mx,My,xs,ys,xm,ym;
<a name="line253">253: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      lambda,temp1,temp,hx,hy;
<a name="line254">254: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    **x;

<a name="line257">257: </a>  <A href="../../../../docs/manualpages/DA/DAGetInfo.html#DAGetInfo">DAGetInfo</A>(user-&gt;da,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,&amp;Mx,&amp;My,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,
<a name="line258">258: </a>                   <A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>);

<a name="line260">260: </a>  lambda = user-&gt;param;
<a name="line261">261: </a>  hx     = 1.0/(<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(Mx-1);
<a name="line262">262: </a>  hy     = 1.0/(<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(My-1);
<a name="line263">263: </a>  temp1  = lambda/(lambda + 1.0);

<a name="line265">265: </a>  <font color="#B22222">/*</font>
<a name="line266">266: </a><font color="#B22222">     Get a pointer to vector data.</font>
<a name="line267">267: </a><font color="#B22222">       - For default PETSc vectors, <A href="../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>() returns a pointer to</font>
<a name="line268">268: </a><font color="#B22222">         the data array.  Otherwise, the routine is implementation dependent.</font>
<a name="line269">269: </a><font color="#B22222">       - You MUST call <A href="../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>() when you no longer need access to</font>
<a name="line270">270: </a><font color="#B22222">         the array.</font>
<a name="line271">271: </a><font color="#B22222">  */</font>
<a name="line272">272: </a>  <A href="../../../../docs/manualpages/DA/DAVecGetArray.html#DAVecGetArray">DAVecGetArray</A>(user-&gt;da,X,&amp;x);

<a name="line274">274: </a>  <font color="#B22222">/*</font>
<a name="line275">275: </a><font color="#B22222">     Get local grid boundaries (for 2-dimensional <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>):</font>
<a name="line276">276: </a><font color="#B22222">       xs, ys   - starting grid indices (no ghost points)</font>
<a name="line277">277: </a><font color="#B22222">       xm, ym   - widths of local grid (no ghost points)</font>

<a name="line279">279: </a><font color="#B22222">  */</font>
<a name="line280">280: </a>  <A href="../../../../docs/manualpages/DA/DAGetCorners.html#DAGetCorners">DAGetCorners</A>(user-&gt;da,&amp;xs,&amp;ys,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;xm,&amp;ym,<A href="../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line282">282: </a>  <font color="#B22222">/*</font>
<a name="line283">283: </a><font color="#B22222">     Compute initial guess over the locally owned part of the grid</font>
<a name="line284">284: </a><font color="#B22222">  */</font>
<a name="line285">285: </a>  <font color="#4169E1">for</font> (j=ys; j&lt;ys+ym; j++) {
<a name="line286">286: </a>    temp = (<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(<A href="../../../../docs/manualpages/Sys/PetscMin.html#PetscMin">PetscMin</A>(j,My-j-1))*hy;
<a name="line287">287: </a>    <font color="#4169E1">for</font> (i=xs; i&lt;xs+xm; i++) {
<a name="line288">288: </a>      <font color="#4169E1">if</font> (i == 0 || j == 0 || i == Mx-1 || j == My-1) {
<a name="line289">289: </a>        <font color="#B22222">/* boundary conditions are all zero Dirichlet */</font>
<a name="line290">290: </a>        x[j][i] = 0.0;
<a name="line291">291: </a>      } <font color="#4169E1">else</font> {
<a name="line292">292: </a>        x[j][i] = temp1*sqrt(<A href="../../../../docs/manualpages/Sys/PetscMin.html#PetscMin">PetscMin</A>((<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(<A href="../../../../docs/manualpages/Sys/PetscMin.html#PetscMin">PetscMin</A>(i,Mx-i-1))*hx,temp));
<a name="line293">293: </a>      }
<a name="line294">294: </a>    }
<a name="line295">295: </a>  }

<a name="line297">297: </a>  <font color="#B22222">/*</font>
<a name="line298">298: </a><font color="#B22222">     Restore vector</font>
<a name="line299">299: </a><font color="#B22222">  */</font>
<a name="line300">300: </a>  <A href="../../../../docs/manualpages/DA/DAVecRestoreArray.html#DAVecRestoreArray">DAVecRestoreArray</A>(user-&gt;da,X,&amp;x);

<a name="line302">302: </a>  <font color="#4169E1">return</font>(0);
<a name="line303">303: </a>}
<a name="line304">304: </a><font color="#B22222">/* ------------------------------------------------------------------- */</font>
<a name="line307">307: </a><font color="#B22222">/* </font>
<a name="line308">308: </a><font color="#B22222">   FormFunctionLocal - Evaluates nonlinear function, F(x).</font>

<a name="line310">310: </a><font color="#B22222">       Process adiC(36): FormFunctionLocal</font>

<a name="line312">312: </a><font color="#B22222"> */</font>
<a name="line313">313: </a><strong><font color="#4169E1"><a name="FormFunctionLocal"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> FormFunctionLocal(<A href="../../../../docs/manualpages/DA/DALocalInfo.html#DALocalInfo">DALocalInfo</A> *info,<A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> **x,<A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> **f,AppCtx *user)</font></strong>
<a name="line314">314: </a>{
<a name="line316">316: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,j;
<a name="line317">317: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      lambda,hx,hy,hxdhy,hydhx,sc;
<a name="line318">318: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    u,uxx,uyy;


<a name="line322">322: </a>  lambda = user-&gt;param;
<a name="line323">323: </a>  hx     = 1.0/(<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(info-&gt;mx-1);
<a name="line324">324: </a>  hy     = 1.0/(<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(info-&gt;my-1);
<a name="line325">325: </a>  sc     = hx*hy*lambda;
<a name="line326">326: </a>  hxdhy  = hx/hy;
<a name="line327">327: </a>  hydhx  = hy/hx;
<a name="line328">328: </a>  <font color="#B22222">/*</font>
<a name="line329">329: </a><font color="#B22222">     Compute function over the locally owned part of the grid</font>
<a name="line330">330: </a><font color="#B22222">  */</font>
<a name="line331">331: </a>  <font color="#4169E1">for</font> (j=info-&gt;ys; j&lt;info-&gt;ys+info-&gt;ym; j++) {
<a name="line332">332: </a>    <font color="#4169E1">for</font> (i=info-&gt;xs; i&lt;info-&gt;xs+info-&gt;xm; i++) {
<a name="line333">333: </a>      <font color="#4169E1">if</font> (i == 0 || j == 0 || i == info-&gt;mx-1 || j == info-&gt;my-1) {
<a name="line334">334: </a>        f[j][i] = x[j][i];
<a name="line335">335: </a>      } <font color="#4169E1">else</font> {
<a name="line336">336: </a>        u       = x[j][i];
<a name="line337">337: </a>        uxx     = (2.0*u - x[j][i-1] - x[j][i+1])*hydhx;
<a name="line338">338: </a>        uyy     = (2.0*u - x[j-1][i] - x[j+1][i])*hxdhy;
<a name="line339">339: </a>        f[j][i] = uxx + uyy - sc*PetscExpScalar(u);
<a name="line340">340: </a>      }
<a name="line341">341: </a>    }
<a name="line342">342: </a>  }

<a name="line344">344: </a>  <A href="../../../../docs/manualpages/Profiling/PetscLogFlops.html#PetscLogFlops">PetscLogFlops</A>(11*info-&gt;ym*info-&gt;xm);
<a name="line345">345: </a>  <font color="#4169E1">return</font>(0);
<a name="line346">346: </a>}

<a name="line350">350: </a><font color="#B22222">/*</font>
<a name="line351">351: </a><font color="#B22222">   FormJacobianLocal - Evaluates Jacobian matrix.</font>
<a name="line352">352: </a><font color="#B22222">*/</font>
<a name="line353">353: </a><strong><font color="#4169E1"><a name="FormJacobianLocal"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> FormJacobianLocal(<A href="../../../../docs/manualpages/DA/DALocalInfo.html#DALocalInfo">DALocalInfo</A> *info,<A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> **x,<A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> jac,AppCtx *user)</font></strong>
<a name="line354">354: </a>{
<a name="line356">356: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       i,j;
<a name="line357">357: </a>  <A href="../../../../docs/manualpages/Mat/MatStencil.html#MatStencil">MatStencil</A>     col[5],row;
<a name="line358">358: </a>  <A href="../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    lambda,v[5],hx,hy,hxdhy,hydhx,sc;

<a name="line361">361: </a>  lambda = user-&gt;param;
<a name="line362">362: </a>  hx     = 1.0/(<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(info-&gt;mx-1);
<a name="line363">363: </a>  hy     = 1.0/(<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(info-&gt;my-1);
<a name="line364">364: </a>  sc     = hx*hy*lambda;
<a name="line365">365: </a>  hxdhy  = hx/hy;
<a name="line366">366: </a>  hydhx  = hy/hx;


<a name="line369">369: </a>  <font color="#B22222">/* </font>
<a name="line370">370: </a><font color="#B22222">     Compute entries for the locally owned part of the Jacobian.</font>
<a name="line371">371: </a><font color="#B22222">      - Currently, all PETSc parallel matrix formats are partitioned by</font>
<a name="line372">372: </a><font color="#B22222">        contiguous chunks of rows across the processors. </font>
<a name="line373">373: </a><font color="#B22222">      - Each processor needs to insert only elements that it owns</font>
<a name="line374">374: </a><font color="#B22222">        locally (but any non-local elements will be sent to the</font>
<a name="line375">375: </a><font color="#B22222">        appropriate processor during matrix assembly). </font>
<a name="line376">376: </a><font color="#B22222">      - Here, we set all entries for a particular row at once.</font>
<a name="line377">377: </a><font color="#B22222">      - We can set matrix entries either using either</font>
<a name="line378">378: </a><font color="#B22222">        <A href="../../../../docs/manualpages/Mat/MatSetValuesLocal.html#MatSetValuesLocal">MatSetValuesLocal</A>() or <A href="../../../../docs/manualpages/Mat/MatSetValues.html#MatSetValues">MatSetValues</A>(), as discussed above.</font>
<a name="line379">379: </a><font color="#B22222">  */</font>
<a name="line380">380: </a>  <font color="#4169E1">for</font> (j=info-&gt;ys; j&lt;info-&gt;ys+info-&gt;ym; j++) {
<a name="line381">381: </a>    <font color="#4169E1">for</font> (i=info-&gt;xs; i&lt;info-&gt;xs+info-&gt;xm; i++) {
<a name="line382">382: </a>      row.j = j; row.i = i;
<a name="line383">383: </a>      <font color="#B22222">/* boundary points */</font>
<a name="line384">384: </a>      <font color="#4169E1">if</font> (i == 0 || j == 0 || i == info-&gt;mx-1 || j == info-&gt;my-1) {
<a name="line385">385: </a>        v[0] = 1.0;
<a name="line386">386: </a>        <A href="../../../../docs/manualpages/Mat/MatSetValuesStencil.html#MatSetValuesStencil">MatSetValuesStencil</A>(jac,1,&amp;row,1,&amp;row,v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line387">387: </a>      } <font color="#4169E1">else</font> {
<a name="line388">388: </a>      <font color="#B22222">/* interior grid points */</font>
<a name="line389">389: </a>        v[0] = -hxdhy;                                           col[0].j = j - 1; col[0].i = i;
<a name="line390">390: </a>        v[1] = -hydhx;                                           col[1].j = j;     col[1].i = i-1;
<a name="line391">391: </a>        v[2] = 2.0*(hydhx + hxdhy) - sc*PetscExpScalar(x[j][i]); col[2].j = row.j; col[2].i = row.i;
<a name="line392">392: </a>        v[3] = -hydhx;                                           col[3].j = j;     col[3].i = i+1;
<a name="line393">393: </a>        v[4] = -hxdhy;                                           col[4].j = j + 1; col[4].i = i;
<a name="line394">394: </a>        <A href="../../../../docs/manualpages/Mat/MatSetValuesStencil.html#MatSetValuesStencil">MatSetValuesStencil</A>(jac,1,&amp;row,5,col,v,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>);
<a name="line395">395: </a>      }
<a name="line396">396: </a>    }
<a name="line397">397: </a>  }

<a name="line399">399: </a>  <font color="#B22222">/* </font>
<a name="line400">400: </a><font color="#B22222">     Assemble matrix, using the 2-step process:</font>
<a name="line401">401: </a><font color="#B22222">       <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(), <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>().</font>
<a name="line402">402: </a><font color="#B22222">  */</font>
<a name="line403">403: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(jac,MAT_FINAL_ASSEMBLY);
<a name="line404">404: </a>  <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(jac,MAT_FINAL_ASSEMBLY);
<a name="line405">405: </a>  <font color="#B22222">/*</font>
<a name="line406">406: </a><font color="#B22222">     Tell the matrix we will never add a new nonzero location to the</font>
<a name="line407">407: </a><font color="#B22222">     matrix. If we do, it will generate an error.</font>
<a name="line408">408: </a><font color="#B22222">  */</font>
<a name="line409">409: </a>  <A href="../../../../docs/manualpages/Mat/MatSetOption.html#MatSetOption">MatSetOption</A>(jac,MAT_NEW_NONZERO_LOCATION_ERR);
<a name="line410">410: </a>  <font color="#4169E1">return</font>(0);
<a name="line411">411: </a>}

<a name="line413">413: </a><font color="#B22222">/*</font>
<a name="line414">414: </a><font color="#B22222">      Variant of FormFunction() that computes the function in Matlab</font>
<a name="line415">415: </a><font color="#B22222">*/</font>
<a name="line416">416: </a><font color="#A020F0">#if defined(PETSC_HAVE_MATLAB)</font>
<a name="line417">417: </a><strong><font color="#4169E1"><a name="FormFunctionMatlab"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> FormFunctionMatlab(<A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> snes,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> X,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> F,void *ptr)</font></strong>
<a name="line418">418: </a>{
<a name="line419">419: </a>  AppCtx         *user = (AppCtx*)ptr;
<a name="line421">421: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       Mx,My;
<a name="line422">422: </a>  <A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      lambda,hx,hy;
<a name="line423">423: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            localX,localF;
<a name="line424">424: </a>  <A href="../../../../docs/manualpages/Sys/MPI_Comm.html#MPI_Comm">MPI_Comm</A>       <A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>;

<a name="line427">427: </a>  <A href="../../../../docs/manualpages/DA/DAGetLocalVector.html#DAGetLocalVector">DAGetLocalVector</A>(user-&gt;da,&amp;localX);
<a name="line428">428: </a>  <A href="../../../../docs/manualpages/DA/DAGetLocalVector.html#DAGetLocalVector">DAGetLocalVector</A>(user-&gt;da,&amp;localF);
<a name="line429">429: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectSetName.html#PetscObjectSetName">PetscObjectSetName</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)localX,<font color="#666666">"localX"</font>);
<a name="line430">430: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectSetName.html#PetscObjectSetName">PetscObjectSetName</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)localF,<font color="#666666">"localF"</font>);
<a name="line431">431: </a>  <A href="../../../../docs/manualpages/DA/DAGetInfo.html#DAGetInfo">DAGetInfo</A>(user-&gt;da,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,&amp;Mx,&amp;My,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,
<a name="line432">432: </a>                   <A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>,<A href="../../../../docs/manualpages/Sys/PETSC_IGNORE.html#PETSC_IGNORE">PETSC_IGNORE</A>);

<a name="line434">434: </a>  lambda = user-&gt;param;
<a name="line435">435: </a>  hx     = 1.0/(<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(Mx-1);
<a name="line436">436: </a>  hy     = 1.0/(<A href="../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>)(My-1);

<a name="line438">438: </a>  <A href="../../../../docs/manualpages/Sys/PetscObjectGetComm.html#PetscObjectGetComm">PetscObjectGetComm</A>((<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)snes,&amp;<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>);
<a name="line439">439: </a>  <font color="#B22222">/*</font>
<a name="line440">440: </a><font color="#B22222">     Scatter ghost points to local vector,using the 2-step process</font>
<a name="line441">441: </a><font color="#B22222">        <A href="../../../../docs/manualpages/DA/DAGlobalToLocalBegin.html#DAGlobalToLocalBegin">DAGlobalToLocalBegin</A>(),<A href="../../../../docs/manualpages/DA/DAGlobalToLocalEnd.html#DAGlobalToLocalEnd">DAGlobalToLocalEnd</A>().</font>
<a name="line442">442: </a><font color="#B22222">     By placing code between these two statements, computations can be</font>
<a name="line443">443: </a><font color="#B22222">     done while messages are in transition.</font>
<a name="line444">444: </a><font color="#B22222">  */</font>
<a name="line445">445: </a>  <A href="../../../../docs/manualpages/DA/DAGlobalToLocalBegin.html#DAGlobalToLocalBegin">DAGlobalToLocalBegin</A>(user-&gt;da,X,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,localX);
<a name="line446">446: </a>  <A href="../../../../docs/manualpages/DA/DAGlobalToLocalEnd.html#DAGlobalToLocalEnd">DAGlobalToLocalEnd</A>(user-&gt;da,X,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,localX);
<a name="line447">447: </a>  <A href="../../../../docs/manualpages/Sys/PetscMatlabEnginePut.html#PetscMatlabEnginePut">PetscMatlabEnginePut</A>(<A href="../../../../docs/manualpages/Sys/PETSC_MATLAB_ENGINE_.html#PETSC_MATLAB_ENGINE_">PETSC_MATLAB_ENGINE_</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>),(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)localX);
<a name="line448">448: </a>  <A href="../../../../docs/manualpages/Sys/PetscMatlabEngineEvaluate.html#PetscMatlabEngineEvaluate">PetscMatlabEngineEvaluate</A>(<A href="../../../../docs/manualpages/Sys/PETSC_MATLAB_ENGINE_.html#PETSC_MATLAB_ENGINE_">PETSC_MATLAB_ENGINE_</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>),<font color="#666666">"localF=ex5m(localX,%18.16e,%18.16e,%18.16e)"</font>,hx,hy,lambda);
<a name="line449">449: </a>  <A href="../../../../docs/manualpages/Sys/PetscMatlabEngineGet.html#PetscMatlabEngineGet">PetscMatlabEngineGet</A>(<A href="../../../../docs/manualpages/Sys/PETSC_MATLAB_ENGINE_.html#PETSC_MATLAB_ENGINE_">PETSC_MATLAB_ENGINE_</A>(<A href="../../../../docs/manualpages/Sys/comm.html#comm">comm</A>),(<A href="../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)localF);

<a name="line451">451: </a>  <font color="#B22222">/*</font>
<a name="line452">452: </a><font color="#B22222">     Insert values into global vector</font>
<a name="line453">453: </a><font color="#B22222">  */</font>
<a name="line454">454: </a>  <A href="../../../../docs/manualpages/DA/DALocalToGlobal.html#DALocalToGlobal">DALocalToGlobal</A>(user-&gt;da,localF,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,F);
<a name="line455">455: </a>  <A href="../../../../docs/manualpages/DA/DARestoreLocalVector.html#DARestoreLocalVector">DARestoreLocalVector</A>(user-&gt;da,&amp;localX);
<a name="line456">456: </a>  <A href="../../../../docs/manualpages/DA/DARestoreLocalVector.html#DARestoreLocalVector">DARestoreLocalVector</A>(user-&gt;da,&amp;localF);
<a name="line457">457: </a>  <font color="#4169E1">return</font>(0);
<a name="line458">458: </a>}
<a name="line459">459: </a><font color="#A020F0">#endif</font>

<a name="line463">463: </a><font color="#B22222">/*</font>
<a name="line464">464: </a><font color="#B22222">  MySNESDefaultComputeJacobianColor - Computes the Jacobian using</font>
<a name="line465">465: </a><font color="#B22222">    finite differences and coloring to exploit matrix sparsity. </font>
<a name="line466">466: </a><font color="#B22222">    It is customized from <A href="../../../../docs/manualpages/SNES/SNESDefaultComputeJacobianColor.html#SNESDefaultComputeJacobianColor">SNESDefaultComputeJacobianColor</A>.</font>
<a name="line467">467: </a><font color="#B22222">    The input global vector x1 is scattered to x1_local</font>
<a name="line468">468: </a><font color="#B22222">    which then is passed into <A href="../../../../docs/manualpages/MatFD/MatFDColoringApply.html#MatFDColoringApply">MatFDColoringApply</A>() for reducing the</font>
<a name="line469">469: </a><font color="#B22222">    VecScatterBingin/End.</font>
<a name="line470">470: </a><font color="#B22222">*/</font>
<a name="line471">471: </a><strong><font color="#4169E1"><a name="MySNESDefaultComputeJacobianColor"></a><A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> MySNESDefaultComputeJacobianColor(<A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> snes,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A> x1,<A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *J,<A href="../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A> *B,<A href="../../../../docs/manualpages/Mat/MatStructure.html#MatStructure">MatStructure</A> *flag,void *ctx)</font></strong>
<a name="line472">472: </a>{
<a name="line473">473: </a>  <A href="../../../../docs/manualpages/Mat/MatFDColoring.html#MatFDColoring">MatFDColoring</A>  color = (<A href="../../../../docs/manualpages/Mat/MatFDColoring.html#MatFDColoring">MatFDColoring</A>) ctx;
<a name="line475">475: </a>  <A href="../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       freq,it;
<a name="line476">476: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            f;
<a name="line477">477: </a>  <A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*ff)(void),(*fd)(void);
<a name="line478">478: </a>  void           *fctx;
<a name="line479">479: </a>  <A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>             da;
<a name="line480">480: </a>  <A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            x1_loc;

<a name="line483">483: </a>  <A href="../../../../docs/manualpages/MatFD/MatFDColoringGetFrequency.html#MatFDColoringGetFrequency">MatFDColoringGetFrequency</A>(color,&amp;freq);
<a name="line484">484: </a>  <A href="../../../../docs/manualpages/SNES/SNESGetIterationNumber.html#SNESGetIterationNumber">SNESGetIterationNumber</A>(snes,&amp;it);

<a name="line486">486: </a>  <font color="#4169E1">if</font> ((freq &gt; 1) &amp;&amp; ((it % freq))) {
<a name="line487">487: </a>    PetscInfo2(color,<font color="#666666">"Skipping Jacobian recomputation, it %D, freq %D\n"</font>,it,freq);
<a name="line488">488: </a>    *flag = SAME_PRECONDITIONER;
<a name="line489">489: </a>  } <font color="#4169E1">else</font> {
<a name="line490">490: </a>    PetscInfo2(color,<font color="#666666">"Computing Jacobian, it %D, freq %D\n"</font>,it,freq);
<a name="line491">491: </a>    *flag = SAME_NONZERO_PATTERN;
<a name="line492">492: </a>    <A href="../../../../docs/manualpages/SNES/SNESGetFunction.html#SNESGetFunction">SNESGetFunction</A>(snes,&amp;f,(<A href="../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (**)(<A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A>,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,<A href="../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>,void*))&amp;ff,0);
<a name="line493">493: </a>    <A href="../../../../docs/manualpages/MatFD/MatFDColoringGetFunction.html#MatFDColoringGetFunction">MatFDColoringGetFunction</A>(color,&amp;fd,&amp;fctx);
<a name="line494">494: </a>    <font color="#4169E1">if</font> (fd == ff) { <font color="#B22222">/* reuse function value computed in <A href="../../../../docs/manualpages/SNES/SNES.html#SNES">SNES</A> */</font>
<a name="line495">495: </a>      MatFDColoringSetF(color,f);
<a name="line496">496: </a>    }
<a name="line497">497: </a>    <font color="#B22222">/* Now, get x1_loc and scatter global x1 onto x1_loc */</font>
<a name="line498">498: </a>    da = *(<A href="../../../../docs/manualpages/DA/DA.html#DA">DA</A>*)fctx;
<a name="line499">499: </a>    <A href="../../../../docs/manualpages/DA/DAGetLocalVector.html#DAGetLocalVector">DAGetLocalVector</A>(da,&amp;x1_loc);
<a name="line500">500: </a>    <A href="../../../../docs/manualpages/DA/DAGlobalToLocalBegin.html#DAGlobalToLocalBegin">DAGlobalToLocalBegin</A>(da,x1,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,x1_loc);
<a name="line501">501: </a>    <A href="../../../../docs/manualpages/DA/DAGlobalToLocalEnd.html#DAGlobalToLocalEnd">DAGlobalToLocalEnd</A>(da,x1,<A href="../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,x1_loc);
<a name="line502">502: </a>    <A href="../../../../docs/manualpages/MatFD/MatFDColoringApply.html#MatFDColoringApply">MatFDColoringApply</A>(*B,color,x1_loc,flag,snes);
<a name="line503">503: </a>    <A href="../../../../docs/manualpages/DA/DARestoreLocalVector.html#DARestoreLocalVector">DARestoreLocalVector</A>(da,&amp;x1_loc);
<a name="line504">504: </a>  }
<a name="line505">505: </a>  <font color="#4169E1">if</font> (*J != *B) {
<a name="line506">506: </a>    <A href="../../../../docs/manualpages/Mat/MatAssemblyBegin.html#MatAssemblyBegin">MatAssemblyBegin</A>(*J,MAT_FINAL_ASSEMBLY);
<a name="line507">507: </a>    <A href="../../../../docs/manualpages/Mat/MatAssemblyEnd.html#MatAssemblyEnd">MatAssemblyEnd</A>(*J,MAT_FINAL_ASSEMBLY);
<a name="line508">508: </a>  }
<a name="line509">509: </a>  <font color="#4169E1">return</font>(0);
<a name="line510">510: </a>}







</pre>
</body>

</html>
